# Remplissez les valeurs numriques ci-desssous puis tapez dans maple la fonction : read `/home/chamois/jparment/BIP/Program/Tableau/arti.mpl`; #

#---------------------------------------------------------#
# Spcifications					  #
#---------------------------------------------------------#

# Recommandations #
# Vous devez spcifier l'erreur que vous acceptez sur la cheville (en degrs). #

q2_err_toleree:=1/50:      	#cheville frontale#
q3_err_toleree:=1/50:		#cheville sagittale#
q4_err_toleree:=1/50:		#genou#
q5_err_toleree:=1/50:		#hanche#


fileData:=cat(rep,`artiTab.data`):  #nom du fichier qui contient le tableau de valeurs#
fileC:=cat(rep,`artiTab.c`):  #nom du fichier qui contient les affectations des grandeurs utiles du tableau de valeurs#

Digits:=10: #nombre de chiffres significatifs des calculs#

#---------------------------------------------------------#
# Paramtres physiques					  #
#---------------------------------------------------------#

#---------------------------------------------------------#
# Cheville						  #
#---------------------------------------------------------#

q2_min:=-20    : #(en degrs) Valeur minimale de l'angle articulaire#
q2_max:= 20    : #(en degrs) Extension maximale de l'angle articulaire#
q2_init:= 0    : #(en degrs) Angle articulaire d'initialisation#
q3_min:=-45    : #(en degrs) Valeur minimale de l'angle articulaire#
q3_max:= 45    : #(en degrs) Extension maximale de l'angle articulaire#
q3_init:= 0    : #(en degrs) Angle articulaire d'initialisation#
Pas3:=    4    : #(en mm) Pas de la vis#
e3  :=   51.2  : #(en mm) hauteur de tte de bielette#
l3  :=  125.8  : #(en mm) longueur des bielettes de la jambe (m)#
h3  :=   37.9  : #(en mm) desaxage des ecrous internes et externes #
bp  :=    0    : #(en mm) longueur pour le calcul du bras de levier#
cp  :=   60    : #(en mm) longueur pour le calcul du bras de levier#
dp  :=   37.9  : #(en mm) longueur pour le calcul du bras de levier#
GAM3:=   -5.782: #(en degrs) direction glissiere/jambe (rad)#
PHI3:=  -35.78 : #(en degrs) angle bras de levier/rotule#


#---------------------------------------------------------#
# Genou							  #
#---------------------------------------------------------#
q4_min:=  0   : #(en degrs) Valeur minimale de l'angle articulaire#
q4_max:= 90   : #(en degrs) Extension maximale de l'angle articulaire#
q4_init:= 0   : #(en degrs) Angle articulaire d'initialisation#
Red4  :=  0.6 :	#Rapport de rduction#
Pas4  :=  5   :	#(en mm) Pas de la vis#
e4    := 49   :	#(en mm) hauteur de tte de bielette pour la vis du genou#
l4    :=106.2 :	#(en mm) longueur de bielette de la cuisse#
R4    := 55   :	#(en mm) longueur bras de levier de la jambe#
GAM4  :=  2.51:	#(en degrs) direction glissiere/cuisse#


#---------------------------------------------------------#
# Hanche						  #
#---------------------------------------------------------#
q5_min:= 15   : #(en degrs) Valeur minimale de l'angle articulaire#
q5_max:=105   : #(en degrs) Extension maximale de l'angle articulaire#
q5_init:=90   : #(en degrs) Angle articulaire d'initialisation#
Red5  := -0.6 :	#Rapport de rduction#
Pas5  :=  5   :	#(en mm) Pas de la vis#
e5    := 49   :	#(en mm) hauteur de tte de bielette#
l5    :=150.4 :	#(en mm) longueur de bielette de la cuisse#
R5    := 55   :	#(en mm) longueur bras de levier de la cuisse#
PHI5  := 35   : #(en degrs) angle bras de levier/hanche# 

#---------------------------------------------------------#
# Perturbations						  #
#---------------------------------------------------------#

bruit_top:=0:           #(en radians) bruit sur la lecture de l'angle moteur#
NbrTop:=4096:           #nombre de top codeurs sur un tour#



