#include <math.h>
#include "modulePos.h"


/* Variables globales */
int i,j,arti;   /*index*/
int a[NDDL][2]; /* Numro de la case du tableau de conversion dans laquelle se trouve l'angle moteur absolu theta */

PARAM_TAB pos[NDARTI];

/* Fonction appelle  chaque chantillon  */
void posCompute(double theta[NDDL][2], double Pa[NDDL])
{
  double u[2];    /*position de l'angle lu theta dans la case du tableau de conversion compris entre [0,1]*/
  for(i=0;i<NDDL;i++)
    {
    arti=i%NDARTI;
    
    for(j=0;j<pos[arti].dim;j++){
      u[j]=abs(theta[i][j]-pos[arti].valMin[j])/pos[arti].pas[j]-a[i][j]; 
      printf("art, a  et u : %d %d %g\n",arti,a[i][j],u[j]);
      /* la valeur absolue est l pour traiter le cas de la symtrie par rapport  diff3 */
      
      /* lors d'un mouvement rapide, il est possible de sauter plusieures cases du tableau, d'o la boucle ci-dessous */
      while (u[j]>1) {
	a[i][j]++;
	u[j]-=1;
      }
      while (u[j]<0) {
	a[i][j]--;
	u[j]+=1;
      }
      printf("a et u : %d %g\n",a[i][j],u[j]);
    }
    if (pos[i].dim==1) 
      Pa[i]=(1-u[0])*pos[arti].tab[a[i][0]]+u[0]*pos[arti].tab[a[i][0]+1];
    /* fonction d'interpolation  2D */
    else if (pos[i].dim==2) {
      Pa[i]=(1-u[0])*(1-u[1])*pos[arti].tab[a[i][0]*pos[arti].nbrVal[1]+a[i][1]]+u[0]*(1-u[1])*pos[arti].tab[(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1]]+(1-u[0])*u[1]*pos[arti].tab[a[i][0]*pos[arti].nbrVal[1]+a[i][1]+1]+u[0]*u[1]*pos[arti].tab[(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1]+1];
      printf("%d %d %d %d\n",a[i][0]*pos[arti].nbrVal[1]+a[i][1],(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1],a[i][0]*pos[arti].nbrVal[1]+a[i][1]+1,(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1]+1);
    }
    }
}

/* Fonction d'init    */
void posInit(double theta[NDDL][2], double Pa[NDDL])
{
#include "/home/chamois/jparment/BIP/tableau/artiTab.data"
#include "/home/chamois/jparment/BIP/tableau/artiTab.c"

  for(i=0;i<NDDL;i++)
    {
      arti=i%NDARTI;
      for(j=0;j<pos[arti].dim;j++){
	  /* initialisation du numro de la case du tableau de copnversion dans laquelle se trouve l'angle moteur absolu */
	a[i][j]=(int)floor(abs(theta[i][j]-pos[arti].valMin[j])/pos[arti].pas[j]);
	printf("index %d : %d\n",i,a[i][j]);
	printf("%g %g %g\n",theta[i][j],pos[arti].valMin[j],pos[arti].pas[j]);
	printf("NbrVal : %d\n",pos[arti].nbrVal[j]);
	
      }      
    }
  posCompute(theta,Pa);
  
}


