#include <math.h>
#include "modulePos.h"

#define REP /home/chamois/jparment/BIP/tableau

/* Variables globales */
int i,j,arti;
int a[NDDL][2];
PARAM_TAB pos[NDARTI];

/* Fonction appelle  chaque chantillon  */
void posCompute(double theta[NDDL][2], double Pa[NDDL])
{
  double u[2];
  for(i=0;i<NDDL;i++)
    {
    arti=i%NDARTI;
    
    for(j=0;j<pos[arti].dim;j++){
      u[j]=abs(theta[i][j]-pos[arti].valMin[j])/pos[arti].pas[j]-a[i][j]; 
      printf("art, a  et u : %d %d %g\n",arti,a[i][j],u[j]);
      /* la valeur absolue est l pour traiter le cas de la symtrie par rapport  diff3 */
      
      /* lors d'un mouvement rapide, il est possible de sauter plusieures cases du tableau, d'o la boucle ci-dessous */
      while (u[j]>1) {
	a[i][j]++;
	u[j]-=1;
      }
      while (u[j]<0) {
	a[i][j]--;
	u[j]+=1;
      }
      printf("a et u : %d %g\n",a[i][j],u[j]);
    }
    if (pos[i].dim==1) 
      Pa[i]=(1-u[0])*pos[arti].tab[a[i][0]]+u[0]*pos[arti].tab[a[i][0]+1];
    else if (pos[i].dim==2) {
      Pa[i]=(1-u[0])*(1-u[1])*pos[arti].tab[a[i][0]*pos[arti].nbrVal[1]+a[i][1]]+u[0]*(1-u[1])*pos[arti].tab[(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1]]+(1-u[0])*u[1]*pos[arti].tab[a[i][0]*pos[arti].nbrVal[1]+a[i][1]+1]+u[0]*u[1]*pos[arti].tab[(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1]+1];
      printf("%d %d %d %d\n",a[i][0]*pos[arti].nbrVal[1]+a[i][1],(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1],a[i][0]*pos[arti].nbrVal[1]+a[i][1]+1,(a[i][0]+1)*pos[arti].nbrVal[1]+a[i][1]+1);
    }
    }
}

/* Fonction d'init    */
void posInit(double theta[NDDL][2], double Pa[NDDL])
{
#include "/home/chamois/jparment/BIP/tableau/artiTab.data"
#include "/home/chamois/jparment/BIP/tableau/artiTab.c"
  
  /*Cheville sagitale*/  
  a[CHEV_SAG_DRT][0]=(int)floor(abs(theta[CHEV_SAG_DRT][0]-pos[CHEV_SAG].valMin[0])/pos[CHEV_SAG].pas[0]);
  a[CHEV_SAG_DRT][1]=(int)floor(abs(theta[CHEV_SAG_DRT][1]-pos[CHEV_SAG].valMin[1])/pos[CHEV_SAG].pas[1]);
  
  a[CHEV_SAG_GCH][0]=(int)floor(abs(theta[CHEV_SAG_GCH][0]-pos[CHEV_SAG].valMin[0])/pos[CHEV_SAG].pas[0]);
  a[CHEV_SAG_GCH][1]=(int)floor(abs(theta[CHEV_SAG_GCH][1]-pos[CHEV_SAG].valMin[1])/pos[CHEV_SAG].pas[1]);

  /*Cheville frontale*/  
  a[CHEV_FRON_DRT][0]=(int)floor(abs(theta[CHEV_FRON_DRT][0]-pos[CHEV_FRON].valMin[0])/pos[CHEV_FRON].pas[0]);
  a[CHEV_FRON_DRT][1]=(int)floor(abs(theta[CHEV_FRON_DRT][1]-pos[CHEV_FRON].valMin[1])/pos[CHEV_FRON].pas[1]);
  
  a[CHEV_FRON_GCH][0]=(int)floor(abs(theta[CHEV_SAG_GCH][0]-pos[CHEV_SAG].valMin[0])/pos[CHEV_SAG].pas[0]);
  a[CHEV_SAG_GCH][1]=(int)floor(abs(theta[CHEV_SAG_GCH][1]-pos[CHEV_SAG].valMin[1])/pos[CHEV_SAG].pas[1]);
										/*Genou*/  
  a[GEN_DRT][0]=(int)floor(abs(theta[GEN_DRT][0]-pos[GEN].valMin[0])/pos[GEN].pas[0]);
  a[GEN_GCH][0]=(int)floor(abs(theta[GEN_GCH][0]-pos[GEN].valMin[0])/pos[GEN].pas[0]);

 /*Hanche*/  
  a[HANCHE_DRT][0]=(int)floor(abs(theta[HANCHE_DRT][0]-pos[HANCHE].valMin[0])/pos[HANCHE].pas[0]);
  a[HANCHE_GCH][0]=(int)floor(abs(theta[HANCHE_GCH][0]-pos[HANCHE].valMin[0])/pos[HANCHE].pas[0]);

for(i=0;i<NDDL;i++)
    {
      arti=i%NDARTI;
      for(j=0;j<pos[arti].dim;j++){
	a[i][j]=(int)floor(abs(theta[i][j]-pos[arti].valMin[j])/pos[arti].pas[j]);
	printf("index %d : %d\n",i,a[i][j]);
	printf("%g %g %g\n",theta[i][j],pos[arti].valMin[j],pos[arti].pas[j]);
	printf("NbrVal : %d\n",pos[arti].nbrVal[j]);
	
      }      
    }
  posCompute(theta,Pa);
  
}


